package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.PVPartMapper;
import com.sa.ibiz.demo.demo.domain.PVPart;
import com.sa.ibiz.demo.demo.service.PVPartService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.PVPartSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.PortalPageService;

/**
 * 实体[PVPart] 服务对象接口实现
 */
@Service
public class PVPartServiceImpl extends ServiceImplBase<PVPartMapper, PVPart> implements PVPartService{

    @Autowired
    private PortalPageService portalpageService;

    @Resource
    private PVPartMapper pvpartMapper;


    @Override
    public boolean create(PVPart et) {
        this.beforeCreate(et);
        String primaryKey=et.getPvpartid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setPvpartid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public PVPart get(PVPart et) {
        String primaryKey=et.getPvpartid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setPvpartid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(PVPart et) {
        String primaryKey=et.getPvpartid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setPvpartid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(PVPart et){
        String primaryKey=et.getPvpartid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setPvpartid(primaryKey);
          }
		     this.pvpartMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(PVPart et){
		return et.getPvpartid();  
    }

    @Override
    public boolean getDraft(PVPart et)  {
    if((!StringUtils.isEmpty(et.getPortalpageid())) && et.getPortalpage() == null){
            try {
                et.setPortalpage(portalpageService.getById(et.getPortalpageid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<PVPart> listCurPV(PVPartSearchFilter filter) {
		return pvpartMapper.searchCurPV(filter,filter.getSelectCond());
	}

	public Page<PVPart> searchCurPV(PVPartSearchFilter filter) {
		return pvpartMapper.searchCurPV(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<PVPart> listDefault(PVPartSearchFilter filter) {
		return pvpartMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<PVPart> searchDefault(PVPartSearchFilter filter) {
		return pvpartMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return pvpartMapper.selectRow(sql);
    }

 }